﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;
using GrapeCity.Documents.Excel;

namespace GcExcel_Performance
{
    internal class GcExcel
    {
        public static void Start()
        {
            double setTime, getTime;

            TestCellValues();
            Console.WriteLine();

            Console.WriteLine("Done.....");

            Console.ReadLine();
        }

        public static void TestCellValues()
        {
            var workbook = new Workbook();
            workbook.Open(@"..\..\..\101_Budget_1.xlsx");
            workbook.AutoParse = false;

            var addressAndValues = new List<(string sheetName, string rangeAddress, string value)>();

            using (var fileStream =
                new FileStream(@"..\..\..\Info.Log", FileMode.Open, FileAccess.Read))
            using (var reader = new StreamReader(fileStream, Encoding.UTF8))
            {
                while (!reader.EndOfStream)
                {
                    var currentLine = reader.ReadLine();
                    if (string.IsNullOrEmpty(currentLine)) continue;

                    var settingCellValueIndex =
                        currentLine.IndexOf("Setting cell value", StringComparison.InvariantCultureIgnoreCase);
                    if (settingCellValueIndex == -1) continue;

                    var addressStartBracketIndex = currentLine.IndexOf('[', settingCellValueIndex);
                    if (addressStartBracketIndex == -1) continue;

                    var addressEndBracketIndex = currentLine.IndexOf(']', settingCellValueIndex);
                    if (addressEndBracketIndex == -1) continue;

                    var address = currentLine.Substring(addressStartBracketIndex + 1,
                        addressEndBracketIndex - addressStartBracketIndex - 1);

                    var withValueIndex = currentLine.IndexOf("with value", StringComparison.InvariantCultureIgnoreCase);
                    if (withValueIndex == -1) continue;

                    var valueStartBracketIndex = currentLine.IndexOf('[', withValueIndex);
                    if (valueStartBracketIndex == -1) continue;

                    var valueEndBracketIndex = currentLine.LastIndexOf(']');
                    if (valueEndBracketIndex == -1) continue;

                    var value = currentLine.Substring(valueStartBracketIndex + 1,
                        valueEndBracketIndex - valueStartBracketIndex - 1);

                    var addressInfo = SplitAddress(address);

                    addressAndValues.Add((addressInfo.sheetName, addressInfo.rangeAddress, value));
                }
            }

            var stopwatch = new Stopwatch();
            stopwatch.Start();

            foreach (var addressAndValue in addressAndValues)
                workbook.Worksheets[addressAndValue.sheetName].Range[addressAndValue.rangeAddress].Value =
                    addressAndValue.value;

            stopwatch.Stop();
            var setTime = stopwatch.ElapsedMilliseconds / 1000.0;
            Console.WriteLine("set values for single cell: " + setTime);
            Console.WriteLine("Total cells set: " + addressAndValues.Count);

            (string sheetName, string rangeAddress) SplitAddress(string address)
            {
                var exclamationIndex = address.IndexOf('!');
                if (exclamationIndex == -1) return (null, address);

                var sheetName = address.Substring(0, exclamationIndex);
                var rangeAddress = address.Substring(exclamationIndex + 1);

                return (sheetName, rangeAddress);
            }
        }
    }
}